<template>
    <div>
        <TableHeader datePicker nextFlag theCurrentTime ref="TableHeaderRef">
            <template #select>
                <el-form-item label="用户名称">
                    <el-input v-model="tableStore.table.params.projectName" placeholder="请输入用户名称"></el-input>
                </el-form-item>
                <el-form-item label="所在地市">
                    <el-select v-model="tableStore.table.params.city" clearable placeholder="请选择所在地市">
                        <el-option
                            v-for="item in areaOptionList"
                            :key="item.id"
                            :label="item.name"
                            :value="item.name"
                        ></el-option>
                    </el-select>
                </el-form-item>
            </template>
            <template #operation>
                <!-- <el-button icon='el-icon-Download' type='primary'>导出</el-button> -->
            </template>
        </TableHeader>
        <Table ref="tableRef" />
    </div>

    <el-dialog
        title="干扰源用户详细信息"
        v-model="dialogVisible"
        width="65%"
        :append-to-body="true"
        :close-on-click-modal="false"
        draggable
    >
        <BpmUserReportDetail :id="interId" ref="detailsRef"></BpmUserReportDetail>
    </el-dialog>
    <!-- 查看详情 detail 新增/修改 create-->
    <addForm
        ref="addForms"
        @onSubmit="tableStore.index()"
        :update="update"
        :normalizedControl="true"
        openType="create"
    ></addForm>
</template>
<script setup lang="ts">
defineOptions({
    name: 'supervision/interferenceUserTable'
})

import { ref, onMounted, provide, nextTick } from 'vue'
import TableStore from '@/utils/tableStore'
import Table from '@/components/table/index.vue'
import TableHeader from '@/components/table/header/index.vue'
import { useDictData } from '@/stores/dictData'
import addForm from '@/views/pqs/supervise/interfere/components/undocumented/addForm.vue'
import { getUserReportById } from '@/api/supervision-boot/userReport/form'
import BpmUserReportDetail from '../../components/undocumented/detail.vue'
import { useAdminInfo } from '@/stores/adminInfo'
import { ElMessage, ElMessageBox } from 'element-plus'
import { userReportRenewalCancel } from '@/api/process-boot/generalTest'
const dictData = useDictData()
const areaOptionList = dictData
    .getBasicData('jibei_area')
    .filter(item => !(item.name == '超高压' || item.name == '风光储'))
const statusSelect = dictData.statusSelect()
//获取登陆用户姓名和部门
const adminInfo = useAdminInfo()
const jb_pl = ref(false)
const jb_dky = ref(false)
const update = ref(false)
const addForms = ref()
jb_pl.value =
    adminInfo.$state.roleCode.filter(item => {
        return item == 'jb_pl'
    }).length != 0
        ? true
        : false
jb_dky.value =
    adminInfo.$state.roleCode.filter(item => {
        return item == 'jb_dky'
    }).length != 0
        ? true
        : false

const { push } = useRouter()
const TableHeaderRef = ref()
const tableStore = new TableStore({
    url: '/supervision-boot/userReport/getNormalUserPage',
    publicHeight: 65,
    method: 'POST',
    column: [
        { title: '序号', type: 'seq', width: 80 },
        { field: 'city', title: '所在地市', minWidth: 80 },
        { field: 'projectName', title: '用户名称', minWidth: 170 },
        {
            field: 'userType',
            title: '用户性质',
            minWidth: 150,
            formatter: (obj: any) => {
                const userType = obj.row.userType
                return getUserTypeName(userType)
            }
        },
        // { field: 'responsibleDepartment', title: '归口管理部门', minWidth: 130 },
        {
            field: 'userStatus',
            title: '用户状态',
            minWidth: 100,
            render: 'tag',
            custom: {
                0: 'primary',
                1: 'primary',
                2: 'success',
                3: 'warning'
            },
            replaceValue: {
                0: '可研',
                1: '建设',
                2: '运行',
                3: '退运'
            }
        },
        {
            field: 'status',
            title: '信息更新状态',
            minWidth: 100,
            render: 'tag',
            custom: {
                0: 'warning',
                1: 'primary',
                2: 'success',
                3: 'danger',
                4: 'warning',
                null: 'primary'
            },
            replaceValue: {
                0: '待提交审批',
                1: '审批中',
                2: '审批通过',
                3: '审批不通过',
                4: '已取消',
                null: '/'
            }
        },
        {
            field: 'substation',
            title: '变电站',
            minWidth: 100,
            formatter: (row: any) => {
                row.cellValue = row.cellValue ? row.cellValue : '/'
                return row.cellValue
            }
        },
        {
            title: '详细信息',
            minWidth: 100,
            render: 'buttons',
            buttons: [
                {
                    name: 'productSetting',
                    title: '详情',
                    type: 'primary',
                    icon: 'el-icon-EditPen',
                    render: 'basicButton',
                    click: row => {
                        update.value = row.status == null ? false : true
                        setTimeout(() => {
                            open(row)
                        }, 100)
                    }
                }
            ]
        },
        {
            field: 'createBy',
            title: '填报人',
            minWidth: 80,
            formatter: (row: any) => {
                return dictData.state.userList.filter(item => item.id == row.cellValue)[0]?.name
            }
        },
        // visible:!jb_pl.value && !jb_dky.value?true:false,
        {
            title: '操作',
            minWidth: 180,
            fixed: 'right',
            render: 'buttons',

            buttons: [
                {
                    name: 'productSetting',
                    title: '流程详情',
                    type: 'primary',
                    icon: 'el-icon-EditPen',
                    render: 'basicButton',
                    click: row => {
                        handleAudit(row.processInstanceId, row.historyInstanceId)
                    },
                    disabled: row => {
                        return !row.processInstanceId
                    }
                },
                {
                    name: 'edit',
                    title: '编辑',
                    type: 'primary',
                    icon: 'el-icon-Open',
                    render: 'basicButton',
                    showDisabled: row => {
                        return (
                            row.createBy != adminInfo.$state.id ||
                            !(row.status == 0 || row.status == 2 || row.status == null)
                        )
                    },
                    disabled: row => {
                        return !(row.status == 0 || row.status == 2 || row.status == null)
                    },
                    click: row => {
                        update.value = row.status == null ? false : true
                        setTimeout(() => {
                            addForms.value.open({
                                title: '编辑',
                                row: row
                            })
                        }, 100)
                    }
                },
                {
                    name: 'edit',
                    title: '重新发起',
                    type: 'warning',
                    icon: 'el-icon-Open',
                    render: 'basicButton',
                    disabled: row => {
                        return row.createBy != adminInfo.$state.id || !(row.status == 3 || row.status == 4)
                    },
                    click: row => {
                        addForms.value.open({ title: '重新发起', row: row })
                    }
                },
                {
                    name: 'cancel',
                    title: '取消',
                    type: 'danger',
                    icon: 'el-icon-Open',
                    render: 'basicButton',
                    disabled: row => {
                        return row.createBy != adminInfo.$state.id || row.status != 1
                    },
                    click: row => {
                        cancelLeave(row)
                    }
                },
                {
                    name: 'productSetting',
                    title: '入网设计方案申请',
                    type: 'primary',
                    icon: 'el-icon-EditPen',
                    render: 'basicButton',
                    // disabled: row => {
                    //     return jb_pl.value || jb_dky.value
                    // },
                    click: row => {
                        toFangAn(row, 0)
                    }
                },
                {
                    name: 'productSetting',
                    title: '治理工程验收申请',
                    type: 'primary',
                    icon: 'el-icon-EditPen',
                    render: 'basicButton',
                    disabled: row => {
                        return row.needGovernance == 0
                    },
                    click: row => {
                        toFangAn(row, 1)
                    }
                }

                // {
                //     name: 'productSetting',
                //     title: '/',
                //     type: 'primary',
                //     icon: 'el-icon-EditPen',
                //     render: 'basicButton',
                //     disabled: row => {
                //         return !jb_pl.value && !jb_dky.value
                //     }
                // }
            ]
        }
    ],

    beforeSearchFun: () => {
        tableStore.table.params.orgNo = tableStore.table.params.deptIndex
        tableStore.table.params.relationUserName = tableStore.table.params.userName
    }
})

tableStore.table.params.city = ''
tableStore.table.params.projectName = ''
tableStore.table.params.loadType = ''
tableStore.table.params.userName = ''
tableStore.table.params.relationUserName = ''
tableStore.table.params.aisFileUpload = ''
const dialogVisible = ref(false)
const interId = ref()
provide('tableStore', tableStore)
onMounted(() => {
    tableStore.index()
})
const detailsRef = ref(null)
/** 打开弹窗 */
const open = async val => {
    interId.value = val.id
    dialogVisible.value = true
}

/** 流程实例详情 */
const handleAudit = (instanceId: string, historyInstanceId: string) => {
    push({
        name: 'BpmProcessInstanceDetail',
        state: {
            id: instanceId,
            historyInstanceId
        }
    })
}
/**取消流程操作*/
const cancelLeave = async (row: any) => {
    // 二次确认
    const { value } = await ElMessageBox.prompt('请输入取消原因', '取消流程', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        inputType: 'textarea',
        inputPattern: /^[\s\S]*.*\S[\s\S]*$/, // 判断非空，且非空格
        inputErrorMessage: '取消原因不能为空'
    })
    // 发起取消
    let data = {
        id: row.id,
        processInstanceId: row.processInstanceId,
        reason: value
    }
    await userReportRenewalCancel(data).then(res => {
        ElMessage.success('取消成功')
        // 加载数据
        tableStore.index()
    })
}

const needGovernance = ref()
/** 方案审查 */
const toFangAn = (row: any, typeNo: number) => {
    //查询详情拿到needGovernance
    /** 获得数据 */
    getUserReportById(row.id).then(res => {
        if (res.data.userType == '0' || res.data.userType == '1') {
            needGovernance.value = res.data.userReportProjectPO?.needGovernance
        } else if (
            res.data.userType == '2' ||
            res.data.userType == '3' ||
            res.data.userType == '4' ||
            res.data.userType == '5'
        ) {
            needGovernance.value = res.data.userReportSubstationPO?.needGovernance
        } else if (res.data.userType == '6') {
            needGovernance.value = res.data.userReportSensitivePO?.needGovernance
        }
        push({
            name: 'ProgramReview',
            query: {
                id: row.id,
                type: typeNo,
                needGovernance: needGovernance.value
            }
        })
    })
}

/**获取用户性质*/
const getUserTypeName = (userType: any) => {
    if (userType === 0) {
        return '新建电网工程'
    }
    if (userType === 1) {
        return '扩建电网工程'
    }
    if (userType === 2) {
        return '新建非线性负荷用户'
    }
    if (userType === 3) {
        return '扩建非线性负荷用户'
    }
    if (userType === 4) {
        return '新建新能源发电站'
    }
    if (userType === 5) {
        return '扩建新能源发电站'
    }
    if (userType === 6) {
        return '敏感及重要用户'
    }
    return '新建电网工程'
}
</script>
